%{
	int depth=0,flag=0;
	
	char ops[50];
	int opct=0;
	
	char idents[50][20];
	int idct=0;
	
        void addop(char in)
	{
		/* check for dupes in operators here (if asked) */
                ops[opct++]=in;
	}
	
	void addident(char *in)
	{
		/* check for dupes in identifiers here (if asked) */
		strcpy(idents[idct++],in);
	}	
%}


%%
"(" { if(flag==1) return -1;
      else depth++; 
    }			


")" { if(flag==0) return -1;
      else depth--; if(depth<0) return -1;
    }			


[a-zA-Z0-9]+	{  if(flag==1) return -1;

                   addident(yytext);
                   flag=1;
                }

[+*/-]	 	{ if(flag==0) return -1;

                  addop(yytext[0]);
                  flag=0;
                }

.		{return -1;}		/*On any other character,return invalid*/
\n		{return 0;}		
%%


int main()
{
	int r,i;
	r=yylex();
        if(r==-1 || flag==0 || depth!= 0)
		printf("Invalid Expression\n");
	else
	{
               printf("Valid Expression\n");

                printf("Operators :\n");
		for(i=0;i<opct;i++)
                        printf("%c ",ops[i]);

                printf("\nIdentifiers :\n");
		for(i=0;i<idct;i++)
                        printf("%s ",idents[i]);
	}
	return 0;
}

yywrap() { return 1; }
